当前位置: 代码迷 >> 综合 >> Prime Path POJ - 3126 ( 素数+搜索)
  详细解决方案

Prime Path POJ - 3126 ( 素数+搜索)

热度:25   发布时间:2024-01-20 21:53:15.0

Prime Path

描述

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

1033
1733
3733
3739
3779
8779
8179                                                                                                                                                                                                  

The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

题意:

第一行输入一个值t,有t个测试样例,然后接下来的t行都会有两个数m和n,m和n必须是四位数且都是素数,将m每次只能改变一位数,并且改变一位数之后的数值仍然是素数,要求找出来从m变为n的最少步数。

首先想到的就是广搜,然后每次都分别去改变m的个位,十位,百位,千位;判断改变之后的数要符合是素数并且这个数未曾出现过。直到找到的数等于n为止输出结果,如果无法从m变为n那么输出Impossible。

代码:

#include<iostream>
#include<cstdio>
#include<cstring>
#include<algorithm>
#include<queue>
using namespace std;
int m,n;
int vis[100000];
int check(int a)  //判断此数是否符合为素数并且未出现过
{int flag=0;if(a>=1000&&a<10000&&vis[a]==0){for(int i=2;i*i<=a;i++){if(a%i==0){flag=1;break;} }if(flag==0)return 1;}return 0;
}
struct node{int x,step;
};
void bfs()
{memset(vis,0,sizeof(vis));queue<struct node> q;struct node nod={m,0};q.push(nod);vis[m]=1;while(!q.empty()){struct node newn=q.front();q.pop();if(newn.x==n){printf("%d\n",newn.step);return ;}//个 for(int i=0;i<=9;i++){int tx=i+newn.x/10*10;if(check(tx)){struct node d={tx,newn.step+1};vis[tx]=1;q.push(d);}}//十 for(int i=0;i<=9;i++){int tx=newn.x%10+i*10+newn.x/100*100;if(check(tx)){struct node d={tx,newn.step+1};vis[tx]=1;q.push(d);}}//百 for(int i=0;i<=9;i++){int tx=newn.x%100+i*100+newn.x/1000*1000;if(check(tx)){struct node d={tx,newn.step+1};vis[tx]=1;q.push(d);}}//千 for(int i=1;i<=9;i++){int tx=newn.x%1000+i*1000;if(check(tx)){struct node d={tx,newn.step+1};vis[tx]=1;q.push(d);}}}cout<<"Impossible"<<endl;
}
int main()
{int t;scanf("%d",&t);while(t--){scanf("%d%d",&m,&n);bfs();}return 0;
}

 

  相关解决方案